Imports System.Environment

Module MainModule

    Public frmMain As New MainForm
    Dim AppName As String = Application.ProductName
    Dim ToolTip As New ToolTip, imgAnimFrame(15) As Bitmap
    Public AppVer As String = Application.ProductVersion

    Public Sub Main()
        ' Set some initial variables
        AppVer = AppVer.Substring(0, AppVer.Length - 4)
        frmMain.Text = AppName + " v" + AppVer
        frmMain.OpenFile.InitialDirectory = GetFolderPath(SpecialFolder.Personal)

        ' Set FileHash label tooltip
        ToolTip.InitialDelay = 0
        ToolTip.SetToolTip(frmMain.FileHash, "Right click to copy the hash to the clipboard")

        ' Draw custom menu items
        AddHandler frmMain.MnuItemTitle1.DrawItem, AddressOf DrawCustomMenuItem
        AddHandler frmMain.MnuItemTitle1.MeasureItem, AddressOf StdMeasureItem

        ' Run application with MainForm
        Application.EnableVisualStyles()
        Application.Run(frmMain)
    End Sub

    ' Set custom menu item Width and Height
    Private Sub StdMeasureItem(ByVal sender As Object, ByVal e As MeasureItemEventArgs)
        e.ItemHeight = 14
        e.ItemWidth = 96
    End Sub

    ' Draw custom menu item
    Private Sub DrawCustomMenuItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)
        Dim StartP As Point = New Point(0, 0)
        Dim EndP As Point = New Point(150, 0)
        Dim StartColor As Color = Color.FromArgb(255, 0, 100, 0)
        Dim EndColor As Color = Color.FromArgb(255, 0, 210, 0)
        Dim linearGradient As New Drawing2D.LinearGradientBrush(StartP, EndP, StartColor, EndColor)
        e.Graphics.FillRectangle(linearGradient, 0, 0, e.Bounds.Size.Width, e.Bounds.Size.Height)

        Dim aBrush As New SolidBrush(Color.White)
        Dim aFont As New Font("Tahoma", 8, FontStyle.Bold, GraphicsUnit.Point)
        e.Graphics.DrawString(AppName + " v" + AppVer, aFont, aBrush, e.Bounds.X, e.Bounds.Y)
    End Sub

End Module
