Imports System.IO
Imports System.Text
Imports System.Threading
Imports System.Security.Cryptography

Public Class WaitForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents pbarHashing As System.Windows.Forms.ProgressBar

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(WaitForm))
        Me.pbarHashing = New System.Windows.Forms.ProgressBar
        Me.SuspendLayout()
        '
        'pbarHashing
        '
        Me.pbarHashing.Location = New System.Drawing.Point(12, 12)
        Me.pbarHashing.Name = "pbarHashing"
        Me.pbarHashing.Size = New System.Drawing.Size(226, 23)
        Me.pbarHashing.TabIndex = 0
        '
        'WaitForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(250, 47)
        Me.Controls.Add(Me.pbarHashing)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "WaitForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Computing hash..."
        Me.ResumeLayout(False)

    End Sub

#End Region

    Delegate Sub DisplayHashCallback(ByVal hash As String)
    Delegate Sub ChangeProgressCallback(ByVal value As Integer)

    Dim fileStream As Stream, I As Integer, Reverse As Boolean
    Dim hashComp As New Thread(AddressOf HashComputation)

    ' Set filestream from MainForm
    Public Sub setOpenFile(ByVal _fileStream As Stream)
        fileStream = _fileStream
    End Sub

    ' Second step in the hash calculation process
    Private Sub WaitForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        hashComp.Start()
    End Sub

    ' Closes the current thread and stop timer
    Private Sub WaitForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        hashComp.Abort()
    End Sub

    ' Third and final step in the hash calculation process
    Private Sub HashComputation()
        Dim MD5 As New MD5CryptoServiceProvider
        Dim sHash As String
        Dim chunkSize As Integer
        Dim fChunk() As Byte
        Dim ftDone As Long = 0

        ' Set different chunk size depending on the file size
        If fileStream.Length < 1024000 Then
            chunkSize = 8192
        ElseIf fileStream.Length < 10240000 Then
            chunkSize = 16384
        ElseIf fileStream.Length < 102400000 Then
            chunkSize = 32768
        ElseIf fileStream.Length < 512000000 Then
            chunkSize = 262144
        Else
            chunkSize = 1048576
        End If

        ' Process every chunk of the file
        fChunk = New Byte(chunkSize) {}

        While (fileStream.Length - ftDone) > fChunk.Length
            ' Calculates part of the hash in a chunk of bytes
            fileStream.Read(fChunk, 0, fChunk.Length)
            ftDone += MD5.TransformBlock(fChunk, 0, fChunk.Length, fChunk, 0)

            ' Updates the progressbar progress
            ChangeProgress((ftDone * 100) / fileStream.Length)
        End While

        ' Process final chunk
        fileStream.Read(fChunk, 0, fileStream.Length - ftDone)
        MD5.TransformFinalBlock(fChunk, 0, fileStream.Length - ftDone)

        ' Fully completes the progressbar
        ChangeProgress(100)

        ' Converts the byte hash to string representation
        sHash = BitConverter.ToString(MD5.Hash)
        sHash = sHash.Replace("-", "").ToUpper

        ' Display file hash
        DisplayHash(sHash)
    End Sub

    ' Displays the file hash and closes this form with thread-safe approach
    Private Sub DisplayHash(ByVal hash As String)
        If frmMain.FileHash.InvokeRequired Then
            Dim d As New DisplayHashCallback(AddressOf DisplayHash)
            Me.Invoke(d, New Object() {hash})
        Else
            frmMain.FileHash.Enabled = True
            frmMain.FileHash.Text = hash

            Me.Close()
        End If
    End Sub

    ' Changes the progress bar value with thread-safe approach
    Private Sub ChangeProgress(ByVal value As Integer)
        If Me.pbarHashing.InvokeRequired Then
            Dim d As New ChangeProgressCallback(AddressOf ChangeProgress)
            Me.Invoke(d, New Object() {value})
        Else
            Me.pbarHashing.Value = value
        End If
    End Sub

End Class
